package proxy.command;

import com.google.common.collect.Lists;

import proxy.Proxy;
import proxy.handler.ProxyHandler;
import proxy.packet.C01PacketChatMessage;
import proxy.util.Formatter;

public class CommandPass extends Command {
	private final String name;
	private final String args;
	private final String help;
	
	public CommandPass(String name, String args, String help) {
		this.name = name;
		this.args = args;
		this.help = help;
	}
	
	public String getName() {
		return this.name;
	}

	public String getArgs() {
		return this.args;
	}

	public String getHelp() {
		return this.help;
	}

	public boolean canUse(ProxyHandler player) {
		return player != null && super.canUse(player);
	}

	public void run(Proxy proxy, ProxyHandler player, String[] args) {
		player.sendToServer(new C01PacketChatMessage("/" + this.name + (args.length != 0 ? " " + Formatter.joinSpace(0, args) : "")));
	}
	
	public Iterable<String> complete(Proxy proxy, ProxyHandler player, String[] args, String[] serverMatches) {
		return Lists.newArrayList(serverMatches);
	}
}
