package proxy.command;

import proxy.Proxy;
import proxy.handler.ProxyHandler;
import proxy.util.Permissions;

public class CommandPing extends Command {
	public String getName() {
		return "ping";
	}
	
	public String getHelp() {
		return "Display a players latency";
	}
	
	public String getArgs() {
		return "<player>";
	}

	public void run(Proxy proxy, ProxyHandler player, String[] args) {
		if(player == null && args.length < 1)
			throw new RunException("Please provide a player name");
		ProxyHandler plr = args.length < 1 ? player : proxy.getPlayer(args[0]);
		if(plr == null)
			throw new RunException("'%s' is not online", args[0]);
		if(player != null && plr != player && !player.hasPermission(Permissions.PING_OTHERS))
			throw new RunException("You are not allowed to query the latency of another player");
		sendInfo(player, (plr == player ? "Your latency" : "Latency of %s") + ": %d ms", plr == player ? plr.getPing() : plr.getUsername(), plr.getPing());
	}
	
	public Iterable<String> complete(Proxy proxy, ProxyHandler player, String[] args, String[] serverMatches) {
		return args.length == 1 && (player == null || player.hasPermission(Permissions.PING_OTHERS)) ? proxy.getPlayerNames() : null;
	}
}
