package proxy.packet;

import java.io.IOException;

import proxy.handler.ProxyHandler;
import proxy.network.Packet;
import proxy.network.PacketBuffer;

public class C15PacketClientSettings implements Packet<ProxyHandler>
{
    private byte modelPartFlags;
    
    public C15PacketClientSettings() {
    }
    
    public C15PacketClientSettings(byte modelFlags) {
    	this.modelPartFlags = modelFlags;
    }

    public void readPacketData(PacketBuffer buf) throws IOException
    {
        buf.readStringFromBuffer(7);
        buf.readByte();
        buf.readByte();
        buf.readBoolean();
        this.modelPartFlags = (byte)buf.readUnsignedByte();
    }

    public void writePacketData(PacketBuffer buf) throws IOException
    {
        buf.writeString("en_US");
        buf.writeByte(16);
        buf.writeByte(0);
        buf.writeBoolean(true);
        buf.writeByte(this.modelPartFlags);
    }

    public void processPacket(ProxyHandler handler)
    {
        handler.processClientSettings(this);
    }
    
    public byte getModelFlags() {
    	return this.modelPartFlags;
    }
}
