package proxy.packet;

import java.io.IOException;

import proxy.handler.LoginHandler;
import proxy.network.Packet;
import proxy.network.PacketBuffer;

public class L00PacketLoginStart implements Packet<LoginHandler>
{
    private String profile;

    public L00PacketLoginStart()
    {
    }

    public L00PacketLoginStart(String profileIn)
    {
        this.profile = profileIn;
    }

    /**
     * Reads the raw packet data from the data stream.
     */
    public void readPacketData(PacketBuffer buf) throws IOException
    {
        this.profile = buf.readStringFromBuffer(16);
    }

    /**
     * Writes the raw packet data to the data stream.
     */
    public void writePacketData(PacketBuffer buf) throws IOException
    {
        buf.writeString(this.profile);
    }

    /**
     * Passes this Packet on to the NetHandler for processing.
     */
    public void processPacket(LoginHandler handler)
    {
        handler.processLoginStart(this);
    }

    public String getProfile()
    {
        return this.profile;
    }
}
