package proxy.packet;

import java.io.IOException;
import java.util.Map;
import java.util.Map.Entry;

import com.google.common.collect.Maps;

import proxy.handler.ProxyHandler;
import proxy.network.Packet;
import proxy.network.PacketBuffer;

public class S37PacketStatistics implements Packet<ProxyHandler>
{
    private Map<String, Integer> field_148976_a;

    /**
     * Passes this Packet on to the NetHandler for processing.
     */
    public void processPacket(ProxyHandler handler)
    {
        handler.handleStatistics(this);
    }

    /**
     * Reads the raw packet data from the data stream.
     */
    public void readPacketData(PacketBuffer buf) throws IOException
    {
        int i = buf.readVarIntFromBuffer();
        this.field_148976_a = Maps.<String, Integer>newHashMap();

        for (int j = 0; j < i; ++j)
        {
            String statbase = buf.readStringFromBuffer(32767);
            int k = buf.readVarIntFromBuffer();

            if (statbase != null)
            {
                this.field_148976_a.put(statbase, Integer.valueOf(k));
            }
        }
    }

    /**
     * Writes the raw packet data to the data stream.
     */
    public void writePacketData(PacketBuffer buf) throws IOException
    {
        buf.writeVarIntToBuffer(this.field_148976_a.size());

        for (Entry<String, Integer> entry : this.field_148976_a.entrySet())
        {
            buf.writeString(entry.getKey());
            buf.writeVarIntToBuffer(((Integer)entry.getValue()).intValue());
        }
    }
}
