package proxy.packet;

import java.io.IOException;

import proxy.handler.ProxyHandler;
import proxy.network.Packet;
import proxy.network.PacketBuffer;

public class S3BPacketScoreboardObjective implements Packet<ProxyHandler>
{
    private String objectiveName;
    private String objectiveValue;
    private String type;
    private int mode;
    
    public S3BPacketScoreboardObjective() {
    }
    
    public S3BPacketScoreboardObjective(String name, String value, String type, int mode) {
    	this.objectiveName = name;
    	this.objectiveValue = value;
    	this.type = type;
    	this.mode = mode;
    }
    
    /**
     * Reads the raw packet data from the data stream.
     */
    public void readPacketData(PacketBuffer buf) throws IOException
    {
        this.objectiveName = buf.readStringFromBuffer(16);
        this.mode = buf.readByte();

        if (this.mode == 0 || this.mode == 2)
        {
            this.objectiveValue = buf.readStringFromBuffer(32);
            this.type = buf.readStringFromBuffer(16);
        }
    }

    /**
     * Writes the raw packet data to the data stream.
     */
    public void writePacketData(PacketBuffer buf) throws IOException
    {
        buf.writeString(this.objectiveName);
        buf.writeByte(this.mode);

        if (this.mode == 0 || this.mode == 2)
        {
            buf.writeString(this.objectiveValue);
            buf.writeString(this.type);
        }
    }

    /**
     * Passes this Packet on to the NetHandler for processing.
     */
    public void processPacket(ProxyHandler handler)
    {
    }
}
